# dhm.h File Reference

## Detailed Description

Copyright (C) 2006-2009, Paul Bakker <polarssl_maintainer at polarssl.org> All rights reserved.

Joined copyright on original XySSL code with: Christophe Devine

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Definition in file dhm.h.

`#include "polarssl/bignum.h"`

Go to the source code of this file.

## Data Structures
struct | dhm_context
## Defines
#define | POLARSSL_ERR_DHM_BAD_INPUT_DATA 0x0480
#define | POLARSSL_ERR_DHM_CALC_SECRET_FAILED 0x04D0
#define | POLARSSL_ERR_DHM_MAKE_PARAMS_FAILED 0x04A0
#define | POLARSSL_ERR_DHM_MAKE_PUBLIC_FAILED 0x04C0
#define | POLARSSL_ERR_DHM_READ_PARAMS_FAILED 0x0490
#define | POLARSSL_ERR_DHM_READ_PUBLIC_FAILED 0x04B0
## Functions
int | dhm_calc_secret (dhm_context *ctx, unsigned char *output, int *olen)
| Derive and export the shared secret (G^Y)^X mod P.
void | dhm_free (dhm_context *ctx)
int | dhm_make_params (dhm_context *ctx, int s_size, unsigned char *output, int *olen, int(*f_rng)(void *), void *p_rng)
| Setup and write the ServerKeyExchange parameters.
int | dhm_make_public (dhm_context *ctx, int s_size, unsigned char *output, int olen, int(*f_rng)(void *), void *p_rng)
| Create own private value X and export G^X.
int | dhm_read_params (dhm_context *ctx, unsigned char **p, unsigned char *end)
| Parse the ServerKeyExchange parameters.
int | dhm_read_public (dhm_context *ctx, unsigned char *input, int ilen)
| Import the peer's public value G^Y.
int | dhm_self_test (int verbose)
| Checkup routine.

## Define Documentation

#define POLARSSL_ERR_DHM_BAD_INPUT_DATA 0x0480

Definition at line 28 of file dhm.h.

#define POLARSSL_ERR_DHM_CALC_SECRET_FAILED 0x04D0

Definition at line 33 of file dhm.h.

#define POLARSSL_ERR_DHM_MAKE_PARAMS_FAILED 0x04A0

Definition at line 30 of file dhm.h.

#define POLARSSL_ERR_DHM_MAKE_PUBLIC_FAILED 0x04C0

Definition at line 32 of file dhm.h.

#define POLARSSL_ERR_DHM_READ_PARAMS_FAILED 0x0490

Definition at line 29 of file dhm.h.

#define POLARSSL_ERR_DHM_READ_PUBLIC_FAILED 0x04B0

Definition at line 31 of file dhm.h.

## Function Documentation

int dhm_calc_secret | ( | dhm_context * | ctx,
|  | unsigned char * | output,
|  | int * | olen |
| ) |  |  |

Derive and export the shared secret (G^Y)^X mod P.

Parameters:

  | ctx | DHM context
  | output | destination buffer
  | olen | number of chars written

Returns:
  0 if successful, or an POLARSSL_ERR_DHM_XXX error code

void dhm_free | ( | dhm_context * | ctx | ) |

int dhm_make_params | ( | dhm_context * | ctx,
|  | int | s_size,
|  | unsigned char * | output,
|  | int * | olen,
|  | int(*)(void *) | f_rng,
|  | void * | p_rng |
| ) |  |  |

Setup and write the ServerKeyExchange parameters.

Parameters:

  | ctx | DHM context
  | x_size | private value size in bits
  | output | destination buffer
  | olen | number of chars written
  | f_rng | RNG function
  | p_rng | RNG parameter

Note:
  This function assumes that ctx->P and ctx->G have already been properly set (for example using mpi_read_string or mpi_read_binary).

Returns:
  0 if successful, or an POLARSSL_ERR_DHM_XXX error code

int dhm_make_public | ( | dhm_context * | ctx,
|  | int | s_size,
|  | unsigned char * | output,
|  | int | olen,
|  | int(*)(void *) | f_rng,
|  | void * | p_rng |
| ) |  |  |

Create own private value X and export G^X.

Parameters:

  | ctx | DHM context
  | x_size | private value size in bits
  | output | destination buffer
  | olen | must be equal to ctx->P.len
  | f_rng | RNG function
  | p_rng | RNG parameter

Returns:
  0 if successful, or an POLARSSL_ERR_DHM_XXX error code

int dhm_read_params | ( | dhm_context * | ctx,
|  | unsigned char ** | p,
|  | unsigned char * | end |
| ) |  |  |

Parse the ServerKeyExchange parameters.

Parameters:

  | ctx | DHM context
  | p | &(start of input buffer)
  | end | end of buffer

Returns:
  0 if successful, or an POLARSSL_ERR_DHM_XXX error code

int dhm_read_public | ( | dhm_context * | ctx,
|  | unsigned char * | input,
|  | int | ilen |
| ) |  |  |

Import the peer's public value G^Y.

Parameters:

  | ctx | DHM context
  | input | input buffer
  | ilen | size of buffer

Returns:
  0 if successful, or an POLARSSL_ERR_DHM_XXX error code

int dhm_self_test | ( | int | verbose | ) |

Checkup routine.

Returns:
  0 if successful, or 1 if the test failed